﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Net;

using FluentFTP;


namespace BlendoFTPUploader
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            //Fill in the boxes with the last-used values...
            textbox_FTPsite.Text = Properties.Settings.Default.FTPurl;
            textbox_Username.Text = Properties.Settings.Default.FTPusername;
            textbox_Password.Text = Properties.Settings.Default.FTPpassword;
            textbox_Localpath.Text = Properties.Settings.Default.LocalPath;
            textbox_Remotepath.Text = Properties.Settings.Default.RemotePath;


            button_Connect.Focus();
            button_Connect.Select();

            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(ManualClose);
        }

        private void ManualClose(object sender, FormClosingEventArgs e)
        {

            //save the field values:
            Properties.Settings.Default.FTPurl = textbox_FTPsite.Text;
            Properties.Settings.Default.FTPusername = textbox_Username.Text;
            Properties.Settings.Default.FTPpassword = textbox_Password.Text;
            Properties.Settings.Default.LocalPath = textbox_Localpath.Text;
            Properties.Settings.Default.RemotePath = textbox_Remotepath.Text;

            Properties.Settings.Default.Save();
        }

        private void button_Connect_Click(object sender, EventArgs e)
        {
            


            //TODO: check if local folder exists.


            SetAllControlsEnabled(false);

            FtpClient client = new FtpClient(textbox_FTPsite.Text);
            client.Credentials = new NetworkCredential(textbox_Username.Text, textbox_Password.Text);

            try
            {
                client.Connect();
            }
            catch (Exception exception)
            {
                MessageBox.Show(exception.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                SetAllControlsEnabled(true);
                return;
            }

            if (!client.IsConnected)
            {
                MessageBox.Show("Failed to connect to FTP server.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                SetAllControlsEnabled(true);
                return;
            }



            FileList fileScreen = new FileList(client, textbox_Localpath.Text , textbox_Remotepath.Text, this);

            if (fileScreen.Enabled)
                fileScreen.ShowDialog();
            

        }

        public void SetAllControlsEnabled(bool value)
        {
            Enabled = value;

            this.Update();
            this.Refresh();
            this.Update();
            this.Refresh();
        }
    }
}
